apiVersion: template.openshift.io/v1
kind: Template
labels:
  mylabel: segnalazioni
  app.kubernetes.io/part-of: segnalazioni
message: template per applicazione sulle segnalazioni
metadata:
  name: template-segnalazioni
  annotations:
    description: "Applicazione delle segnalazioni"
    iconClass: icon-spring-boot
objects:
- apiVersion: apps.openshift.io/v1
  kind: DeploymentConfig
  metadata:
    name: backend
    labels:
      app: backend
  spec:
    selector:
      deploymentconfig: backend
    replicas: 1
    template:
      metadata:
        labels:
          deploymentconfig: backend
          app: backend
      spec:
        containers:
          - env:
            - name: PROTOCOLLO-USER
              value: ${PROTOCOLLO_USER}
            - name: PROTOCOLLO-PASSWORD
              value: ${PROTOCOLLO_PASSWORD}
            - name: MONGO-URI
              value: ${MONGO_URI}
            - name: CLAMAV-URL
              value: ${CLAMAV_URL}
            - name: CLAMAV-PORT
              value: ${CLAMAV_PORT}
            - name: MAIL-HOST
              value: ${MAIL_HOST}
            - name: MAIL-PORT
              value: ${MAIL_PORT}
            - name: MAIL-USERNAME
              value: ${MAIL_USERNAME}
            - name: MAIL-PASSWORD
              value: ${MAIL_PASSWORD}
            - name: MAIL-AUTH
              value: ${MAIL_AUTH}
            - name: MAIL-STARTTLS
              value: ${MAIL_STARTTLS}
            name: backend
            image: segnalazioni-backend:prod    
            ports:
              - containerPort: 8080
                protocol: TCP
            imagePullPolicy: Always
        restartPolicy: Always
    triggers:
      - type: ConfigChange
      - type: ImageChange
        imageChangeParams:
          automatic: true       
          containerNames:
            - backend
          from:
            kind: ImageStreamTag
            namespace: segnalazioni-dev
            name: 'segnalazioni-backend:prod'
- apiVersion: v1
  kind: Service
  metadata:
    name: backend
    labels:
      app: backend
  spec:
    ports:
      - name: 8080-backend-tcp
        protocol: TCP
        port: 80
        targetPort: 8080
    selector:
      app: backend
    type: ClusterIP
    sessionAffinity: None
- apiVersion: route.openshift.io/v1
  kind: Route
  metadata:
    name: backend
    labels:
      app: backend
  spec:
    to:
      kind: Service
      name: backend
      weight: 100
    port:
      targetPort: 8080-backend-tcp
    wildcardPolicy: None

parameters:
- description: uri mongo
  name: MONGO_URI
  required: true
- description: user protocollo
  name: PROTOCOLLO_USER
  required: true
- description: password protocollo
  name: PROTOCOLLO_PASSWORD
  required: true
- description: antivirus clamav URL
  name: CLAMAV_URL
  required: true
- description: antivirus clamav PORT
  name: CLAMAV_PORT
  required: true
- description: mail host
  name: MAIL_HOST
  required: true
- description: mail port
  name: MAIL_PORT
  required: true
- description: mail username
  name: MAIL_USERNAME
  required: true
- description: mail password
  name: MAIL_PASSWORD
  required: true
- description: mail auth
  name: MAIL_AUTH
  required: true
- description: mail starttls
  name: MAIL_STARTTLS
  required: true